package example2_Balls;

import java.util.Date;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import com.threecoffee.anim.Actor;
import com.threecoffee.anim.Sprite;

public class Ball extends Sprite {

	int xvel=1, yvel=1;
	
	Ball(){
		setRandomVel();
		
		addImage(new ImageIcon("media/balls/sprites/ball/1.png"));
		addImage(new ImageIcon("media/balls/sprites/ball/2.png"));
		addImage(new ImageIcon("media/balls/sprites/ball/3.png"));
		setDelay(5);
	}
	
	public void update(){
		moveSprite(xvel, yvel);
		
		if(getX()+getWidth()>=getGameWindow().getWidth() || getX()<=0)
			xvel *= -1;
		if(getY()+getHeight()>=getGameWindow().getHeight()-20 || getY()<=0)
			yvel *= -1;
	}
	
	public void setVel(int x, int y){
		xvel = x;
		yvel = y;
	}
	
	public void setRandomVel(){
		Random r = new Random();
		xvel = r.nextInt(2)+1;
		yvel = r.nextInt(2)+1;
		
		if(r.nextBoolean())
			xvel *= -1;
		if(r.nextBoolean())
			yvel *= -1;
	}
	
	public double getVel(){
		return Math.sqrt(xvel*xvel + yvel*yvel);
	}
	
	public void collided(Sprite s){
		if(Math.abs((s.getX()+s.getWidth()/2)-(getX()+getWidth()/2))<=20 && getY()+getHeight()>=s.getY()+10){
			
			Game.curr = new Date();
			Game.time = (int) (Math.abs(Game.init.getTime() - Game.curr.getTime())/1000);
			
			getGameWindow().pause(true);
			
			((Actor)s).setCurrentAnimation(3);
			s.pause(false);
			
			Game.ended = true;
			s.setGravity(true);
			s.getGravity().setDelay(50);
			
			getGameWindow().setAlwaysOnTop(false);
			JOptionPane.showMessageDialog(getGameWindow(), "You survived for "+(Game.time-Game.ptime)+" seconds.");
			
			Highscores h = new Highscores();
			h.addScore(Game.time-Game.ptime);
			h.display();
		}
	}
}